org.apache.commons.math3.optimization.univariate

## Class BrentOptimizer

- java.lang.Object
- - org.apache.commons.math3.optimization.univariate.BaseAbstractUnivariateOptimizer
  - - org.apache.commons.math3.optimization.univariate.BrentOptimizer

- All Implemented Interfaces:
    BaseOptimizer<UnivariatePointValuePair>, BaseUnivariateOptimizer<UnivariateFunction>, UnivariateOptimizer

      public class BrentOptimizer
      extends BaseAbstractUnivariateOptimizer

  Implements Richard Brent's algorithm (from his book "Algorithms for Minimization without Derivatives", p. 79) for finding minima of real univariate functions. This implementation is an adaptation partly based on the Python code from SciPy (module "optimize.py" v0.5). If the function is defined on some interval `(lo, hi)`, then this method finds an approximation `x` to the point at which the function attains its minimum.
  Since:
    2.0
  Version:
    $Id: BrentOptimizer.java 1244107 2012-02-14 16:17:55Z erans $

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BrentOptimizer(double rel, double abs)` The arguments are used implement the original stopping criterion of Brent's algorithm.
    `BrentOptimizer(double rel, double abs, ConvergenceChecker<UnivariatePointValuePair> checker)` The arguments are used implement the original stopping criterion of Brent's algorithm.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected UnivariatePointValuePair` | `doOptimize()` Method for implementing actual optimization algorithms in derived classes.

    - ### Methods inherited from class org.apache.commons.math3.optimization.univariate.BaseAbstractUnivariateOptimizer

      `computeObjectiveValue, getConvergenceChecker, getEvaluations, getGoalType, getMax, getMaxEvaluations, getMin, getStartValue, optimize, optimize`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BrentOptimizer

          public BrentOptimizer(double rel,
                        double abs,
                        ConvergenceChecker<UnivariatePointValuePair> checker)

      The arguments are used implement the original stopping criterion of Brent's algorithm. `abs` and `rel` define a tolerance `tol = rel |x| + abs`. `rel` should be no smaller than 2 macheps and preferably not much less than sqrt(macheps), where macheps is the relative machine precision. `abs` must be positive.
      Parameters:
        `rel` - Relative threshold.
        `abs` - Absolute threshold.
        `checker` - Additional, user-defined, convergence checking procedure.
      Throws:
        `NotStrictlyPositiveException` - if `abs <= 0`.
        `NumberIsTooSmallException` - if `rel < 2 * Math.ulp(1d)`.

    - #### BrentOptimizer

          public BrentOptimizer(double rel,
                        double abs)

      The arguments are used implement the original stopping criterion of Brent's algorithm. `abs` and `rel` define a tolerance `tol = rel |x| + abs`. `rel` should be no smaller than 2 macheps and preferably not much less than sqrt(macheps), where macheps is the relative machine precision. `abs` must be positive.
      Parameters:
        `rel` - Relative threshold.
        `abs` - Absolute threshold.
      Throws:
        `NotStrictlyPositiveException` - if `abs <= 0`.
        `NumberIsTooSmallException` - if `rel < 2 * Math.ulp(1d)`.

  - ### Method Detail

    - #### doOptimize

          protected UnivariatePointValuePair doOptimize()

      Method for implementing actual optimization algorithms in derived classes.
      Specified by:
        `doOptimize` in class `BaseAbstractUnivariateOptimizer`
      Returns:
        the optimum and its corresponding function value.

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.